import { ElementOf } from 'typescript-miscellaneous';
/**
 * @private
 */
interface ArrayLike<Element = any> extends Iterable<Element> {
    readonly [index: number]: Element;
    readonly length: number;
}
declare function create<Array extends ArrayLike>(elementEqual?: create.ElementEqual<Array>): create.ArrayEqual<Array>;
declare namespace create {
    interface ArrayEqual<Array extends ArrayLike> {
        (a: Array, b: Array): boolean;
    }
    interface ElementEqual<Array extends ArrayLike> {
        (a: ElementOf<Array>, b: ElementOf<Array>, fn: ArrayEqual<Array>): boolean;
    }
    namespace ElementEqual {
        const DEFAULT: (a: any, b: any) => boolean;
    }
}
export = create;
