"use strict";
const iter_tools_1 = require("iter-tools");
function create(elementEqual = create.ElementEqual.DEFAULT) {
    const arrayEqual = (al, bl) => {
        if (al.length !== bl.length)
            return false;
        for (const [ax, bx] of iter_tools_1.zip(al, bl)) {
            if (!elementEqual(ax, bx, arrayEqual))
                return false;
        }
        return true;
    };
    return arrayEqual;
}
(function (create) {
    let ElementEqual;
    (function (ElementEqual) {
        ElementEqual.DEFAULT = (a, b) => Object.is(a, b);
    })(ElementEqual = create.ElementEqual || (create.ElementEqual = {}));
})(create || (create = {}));
module.exports = create;
//# sourceMappingURL=index.js.map